<template>
  <ms-modal
    :v-model="vModel"
    :id="GLOBALS.__APP_NAME__ + '-edit-category-modal'"
    :title="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.modals.editCategory.title`))"
    :ok="ok"
    :ok-title="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.modals.editCategory.okTitle`))"
    :ok-state="isValid"
    :cancel="cancel"
    :cancel-title="$h.capitalize($t(`global.cancel`))"
    :hide-buttons="!showModalContent"
    @ok="$emit('ok')"
    @cancel="$emit('cancel')"
  >
    <transition
      mode="out-in"
      enter-active-class="animated fadeIn fast"
      leave-active-class="animated fadeOut fast"
    >
      <div :id="GLOBALS.__APP_NAME__ + '-edit-category-modal'" v-if="showModalContent" key="modal-content">
        <b-form>
          <!-- Label input -->
          <b-form-group
            id="input-group-label"
            :label="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.global.label`) + ':')"
            label-for="edit-category-input-label"
          >
            <b-form-input
              v-model="editedCategory.label"
              id="edit-category-input-label"
              type="text"
              :state="labelState"
              required
              placeholder="label"
              class="ms_input mb-2"
            />
          </b-form-group>
          <!-- Color label -->
          <label for="edit-category-input-color">{{ $t(`global.color`) | capitalize }}:</label>
          <!-- Color picker -->
          <ms-color-picker
            :color="editedCategory.color"
            class="edit-category-color-picker"
            @update="pickColor"
          ></ms-color-picker>
          <!-- Color input -->
          <div class="color-picker-input">
            <b-form-input
              v-model="editedCategory.color"
              id="edit-category-input-color"
              type="text"
              :state="colorState"
              :formatter="colorFormatter"
              required
              :placeholder="GLOBALS.__APP_COLOR__"
              class="ms_input mb-2"
            />
            <div class="color-picker-input-indicator" :style="'background-color: ' + editedCategory.color + ';'"></div>
          </div>
        </b-form>
        <!-- Delete button -->
        <p class="edit-category-delete-button" @click="handleDelete">
          <v-icon name="times-circle"></v-icon>
          <span>{{ $t(`${GLOBALS.__T_PREFIX__}.modals.editCategory.deleteCategory`) | capitalize }}</span>
        </p>
      </div>
      <div v-else key="modal-loading">
        <icon-basic-load width="28" height="28"/>
        <span>{{ $t("global.loading") }}</span>
      </div>
    </transition>
    <!-- Confirm deleting modal -->
    <ms-modal
      :v-model="showConfirmDeleting"
      :id="GLOBALS.__APP_NAME__ + '-delete-category-modal'"
      :ok="deleteCategory"
      :ok-title="$h.capitalize($t(`global.confirm`))"
      :cancel="cancelDelete"
      :cancel-title="$h.capitalize($t(`global.cancel`))"
    >
      <i18n :path="`${GLOBALS.__T_PREFIX__}.modals.deleteCategory.confirmDeleteMessage`" tag="p">
        <!-- ref: {0} -->
        <br/>
      </i18n>
    </ms-modal>
  </ms-modal>
</template>

<script>
import { BaseComponent } from '@/utils/'

export default {
  extends: BaseComponent,
  data () {
    return {
      editedCategory: null, // Init in mounted ()
      showConfirmDeleting: false
    }
  },
  computed: {
    colorState: function () {
      const regex = /^#[ABCDEF0-9]{6}$/
      if (regex.test(this.editedCategory.color)) {
        return true
      } else {
        return false
      }
    },
    labelState: function () {
      return this.editedCategory.label.length > 0
    },
    isValid: function () {
      return this.editedCategory && this.labelState && this.colorState
    },
    showModalContent: function () {
      return !this.categoriesDeleting && !this.categoriesUpdating && !this.categoriesLoading && this.editedCategory
    }
  },
  props: {
    // V-Model: to show the modal
    vModel: {
      type: Boolean,
      default: false
    },
    // Category object
    category: Object
  },
  methods: {
    ok: async function () {
      await this.updateCategories(this.editedCategory)
      await this.loadCategories()
      return true
    },
    cancel: function () {
      return true
    },
    colorFormatter: function (value) {
      return value.toUpperCase()
    },
    pickColor: function (val) {
      this.editedCategory.color = val.hex
    },
    handleDelete: function () {
      this.showConfirmDeleting = true
    },
    cancelDelete: function () {
      this.showConfirmDeleting = false
    },
    deleteCategory: async function () {
      this.showConfirmDeleting = false
      // Try to delete category
      const categoryId = this.category.id
      const deleteResponse = await this.deleteCategories(this.category)
      // If success
      if (!(deleteResponse instanceof Error)) {
        // Reload categories
        await this.loadCategories()
        // Clean feeds for deleted category
        const cleanedFeeds = this.feeds.reduce((array, feed) => {
          if (feed.category_id !== categoryId) {
            array.push(feed)
          }
          return array
        }, [])
        this.SET_FEEDS(cleanedFeeds)
      }
      this.$emit('ok') // To close modal after deleting
      return true
    }
  },
  state: {
    MyFeedsModule: [
      'feeds',
      'categoriesLoading',
      'categoriesUpdating',
      'categoriesDeleting'
    ]
  },
  actions: {
    MyFeedsModule: [
      'loadCategories',
      'updateCategories',
      'deleteCategories'
    ]
  },
  mutations: {
    MyFeedsModule: [
      'SET_FEEDS'
    ]
  },
  mounted () {
    this.editedCategory = this.category
  },
  watch: {
    category: function (to, from) {
      this.editedCategory = this.category
    }
  }
}
</script>
